#if (use_build=1)
// mesh buildings (wings) (for distant ones)
#include "buildingl1.inc"
#include "buildingl2.inc"
#include "buildingl3.inc"
#include "buildingl4.inc"
#include "buildingl5.inc"
// hf/iso/csg buildings (for close ones)
#include "i_buildings.inc"
// hf windows
#include "i_window.inc"
#include "i_door.inc"
#include "i_door2.inc"
// persiana
#macro persiana(p_nep,p_seed)
#local r_pers=seed(p_seed);
union{
 box{-.5,.5 scale <.85,.06,.01>
  pigment{DarkGreen*.4+ForestGreen*.4+Gray10+Gray20*rand(r_pers)}
 }
 #local iep=0;
 #local nep=p_nep;
 #while (iep<nep)
 union{
  box{-.5,.5 scale <.85,.025,.01>}
  cylinder{.03*y,-.03*y,.001}
  cylinder{.03*y,-.03*y,.001 translate .4*x}
  cylinder{.03*y,-.03*y,.001 translate -.4*x}
  pigment{DarkGreen*.4+ForestGreen*.4+Gray10+Gray20*rand(r_pers)}
  translate (-.055-.03*iep)*y
  translate .0025*cos(.5*iep*360/nep)*z
 }
 #local iep=iep+1;
 #end
 #local p_end=-.055-.03*nep;
 #local iep=0;
 #local nep=20;
 #local p_rad=.07;
 #local p_rdec=.001;
 #while (iep<nep)
 union{
  box{-.5,.5 scale <.85,.025,.01>}
  cylinder{.03*y,-.03*y,.001}
  cylinder{.03*y,-.03*y,.001 translate .4*x}
  cylinder{.03*y,-.03*y,.001 translate -.4*x}
  pigment{DarkGreen*.4+ForestGreen*.4+Gray10+Gray20*rand(r_pers)}
  translate (p_rad-p_rdec*iep)*z
  rotate (430*iep/nep)*x
  translate p_end*y
  translate -p_rad*z
 }
 #local iep=iep+1;
 #end
 union{
  cylinder{<0,0,0>,<0,p_end,-p_rad*2-.002>,.002}
  torus{p_rad+.002,.002 rotate 90*z translate <0,p_end,-p_rad>}
  pigment{Flesh}
 }
}
#end
// toldo
#macro toldo(t_w,t_c)
#local t_toldo=
texture{
 pigment{
  gradient x
  color_map{
   [0.0 t_c*.7+Gray20]
   [0.5 t_c*.7+Gray20]
   [0.0 White]
   [1.0 White]
  }
 }
 scale .33
}
union{
 cylinder{<t_w*.5,0,0>,<t_w*.5,.5,-.5>,.02 texture{Chrome_Metal finish{ambient 0}}}
 cylinder{<-t_w*.5,0,0>,<-t_w*.5,.5,-.5>,.02 texture{Chrome_Metal finish{ambient 0}}}
 cylinder{<-t_w*.5-.01,.5,-.49>,<t_w*.5+.01,.5,-.49>,.02 texture{t_toldo}}
 box{-.5,.5 scale <t_w,.5,.01> 
  texture{t_toldo}
  rotate 51*x 
  translate <0,.67,-.29>
 }
// box{-.5,.5 
 height_field{png "hf_toldo" water_level .1 translate -.5 rotate -90*x
  scale <t_w,.2,.01> 
  texture{t_toldo}
  translate <0,.41,-.5>
 }
}
#end
// procedural roof
#include "i_roof.inc"
// *** SIGNS ***
#include "i_signs.inc"
// roofs
#declare roof1=object{roof(t_roof,14,16,10,1000*rand(r_bd))}
#declare roof2=object{roof(t_roof,14,20,10,1000*rand(r_bd))}
#declare roof3=object{roof(t_roof,14,20,10,1000*rand(r_bd))}
#declare roof4=object{roof(t_roof,14,17,10,1000*rand(r_bd))}
// assign buildings to each street parcel
//#declare bl1=building_1_left(t_wood,t_wall_paint,t_stone,t_ornament,t_glass,t_decor,1000*rand(r_bd))
#declare bl1=
union{
 object{pov_building(400,2,2,0,1,t_wood,t_wall_paint,t_stone,t_ornament,t_glass,t_decor,t_rusty1,1000*rand(r_bd))}
 object{roof1 translate <0,5.1,-.3>}
 object{num_27 scale .01
  translate <.9,2.05,.015>
 }
 object{persiana(20,873) rotate 2*x translate <.91,4.34,.07>}
 translate -.15*z
}
#declare bl2=
union{
 building_2_left(t_wood3,t_wall_paint3,t_stone3,t_rusty1,t_glass,t_wall_paint2b,1000*rand(r_bd))
 object{roof2 translate <0,6.2,-.5>}
 object{num_27 scale .01
  translate <1.4,2.1,-.135>
 }
 object{toldo(.7,SkyBlue) translate <1.4,4.38,0>}
 object{toldo(1.3,SkyBlue) translate <-.9,4.38,0>}
}
#declare bl3=
union{
 pov_building(400,1,1,1,2,t_wood2,t_wall_paint2,t_stone2,t_ornament2,t_glass,t_decor2,texture{Chrome_Metal finish {ambient 0}},1000*rand(r_bd))
 object{roof1 translate <0,5.1,-.3>}
 object{num_27 scale .01
  translate <.9,2.05,.01>
 }
 translate -.15*z
}
#declare bl4=
union{
 building_5_left(t_wood,t_wall_paint,t_decor2,t_ornament,t_glass,t_stone3,t_rusty1,1000*rand(r_bd))
 object{roof4 translate <0,5.2,-.6>}
 object{num_27 scale .01
  translate <.8,2.2,-.135>
 }
 object{window_grill scale <1,1.1,1> texture{T_Chrome_1A finish{ambient 0}} translate <-1,1.32,-.01>}
 object{persiana(10,873) rotate 2*x translate <-.81,4.49,-.06>}
 object{persiana(20,873) rotate 2*x translate <.81,4.49,-.06>}
}
#declare bl5=
union{
 building_4_left(T_Wood4,t_wall_paint5,t_stone2,t_rusty2,t_glass,t_wall_paint2b,1000*rand(r_bd))
 object{roof2 translate <0,6.3,-.5>}
 object{num_27 scale .01
  translate <1.5,2.5,-.135>
 }
 object{no_park scale .01 translate <-.5,1.6,.05>}
}
#declare bl6=
union{
 building_2_left(t_wood2,t_wall_paint6,t_decor,t_ornament2,t_glass,t_stone,1000*rand(r_bd))
 object{roof3 translate <0,6.3,-.5>}
 object{toldo(1.6,OrangeRed) translate <-.81,1.24,0>}
}
#declare bl7=
union{
 building_1_left(T_Wood4,t_wall_paint,t_stone2,t_rusty2,t_glass,t_wall_paint2,1000*rand(r_bd))
 object{roof4 translate <0,5.2,-.6>}
}
#declare bl8=
union{
 building_5_left(t_wood2,t_wall_paint2,t_decor,t_ornament2,t_glass,t_stone,t_rusty2,1000*rand(r_bd))
 object{roof4 translate <0,5.2,-.6>}
}
#end
#if (use_build=2)
#declare bl1=box{-.5,.5 scale <4,5,4> texture{t_wall_paint} translate <0,2.5,2>}
#declare bl2=box{-.5,.5 scale <5,6,4> texture{t_wall_paint3} translate <0,3,2>}
#declare bl3=box{-.5,.5 scale <4,5,4> texture{t_wall_paint2} translate <0,2.5,2>}
#declare bl4=box{-.5,.5 scale <4,5,4> texture{t_wall_paint} translate <0,2.5,2>}
#declare bl5=box{-.5,.5 scale <5,6,4> texture{t_wall_paint5} translate <0,3,2>}
#declare bl6=box{-.5,.5 scale <5,6,4> texture{t_wall_paint6} translate <0,3,2>}
#declare bl7=box{-.5,.5 scale <4,5,4> texture{t_wall_paint} translate <0,2.5,2>}
#declare bl8=box{-.5,.5 scale <4,5,4> texture{t_wall_paint2} translate <0,2.5,2>}
#end
