// building accesories
#declare window_grill=
union{
 height_field{
  png "hf_reja"
  water_level .1
  translate -.5
  rotate -90*x
  scale 1.01
  scale <1.05,1.15,.01>
  translate <0,0,-.15>
 }
 height_field{
  png "hf_reja2"
  water_level .01
  translate -.5
  rotate -90*x
  scale 1.01
  scale <1.05,1.15,.3>
  translate <0,0,-.05>
 }
}

// Two floors building, with configurable details
#macro pov_building(
 hf_res,
 wall_type, // 0=plain, 1=bricks, 2=stones
 use_door,
 use_grill,
 use_decor,
 t_wood,
 t_wall_paint,
 t_decor,
 t_ornament,
 t_glass,
 t_stone,
 t_metal,
 s_bd
)

#local r_bd=seed(s_bd);
#local bd_width=4;
#local bd_height=5;
#local bd_depth=5;
#local bd_wall_width=.3;
#local f_img_bd1=
function{
 pigment{
  image_map{
   png "hf_bd1_1"
  }
 }
}


#local hf_facade=
intersection{
difference{
 height_field{
  function hf_res, hf_res{
  #if (wall_type=0)
   f_img_bd1(x,-y,z).gray*f_granite(x,y,z)*.5
  #end
  #if (wall_type=1)
   f_img_bd1(x,-y,z).gray*f_brick(x*150,y*150,z*150)*f_granite(x,y,z)*.5
  #end
  #if (wall_type=2)
   f_img_bd1(x,-y,z).gray*f_granite(x*15,y*15,z*15)*f_granite(x,y,z)*.5
  #end
  }
  translate -.5
  rotate -90*x
  scale <bd_width,bd_height,bd_wall_width/8>
  translate bd_height*.5*y
 }
 // door
 box{-.5,.5 scale <.98,1.9,bd_wall_width>
  translate <.885,1.9*.5,0>
  translate bd_wall_width*.4*z
 }
 // 1st floor window
 box{-.5,.5 scale <.99,1.19,bd_wall_width>
  translate <-.874,1.3,0>
  translate bd_wall_width*.4*z
 }
 // 2nd floor windows
 box{-.5,.5 scale <.99,1.19,bd_wall_width>
  translate <.89,1.295+2.5,0>
  translate bd_wall_width*.4*z
 }
 box{-.5,.5 scale <.99,1.19,bd_wall_width>
  translate <-.870,1.295+2.5,0>
  translate bd_wall_width*.4*z
 }
}
plane{z,bd_wall_width*.8}
 texture{t_wall_paint}
}

#local ornaments=
union{
 // lower front
 #if (use_decor=1)
 object{rbox2(.02,<bd_width-1.6,.4,bd_wall_width*.25>*.5)
  translate <-.8,.2,-bd_wall_width*.075>
 }
 object{rbox2(.02,<.65,.4,bd_wall_width*.25>*.5)
  translate <1.7,.2,-bd_wall_width*.075>
 }
 #else
 object{rbox2(.02,<bd_width-1.6,.6,bd_wall_width*.25>*.5)
  translate <-.8,.3,-bd_wall_width*.075>
 }
 object{rbox2(.02,<.65,.6,bd_wall_width*.25>*.5)
  translate <1.7,.3,-bd_wall_width*.075>
 }
 #end
 // 1st floor window
 object{rbox2(.01,<.97,.04,bd_wall_width>*.5)
  translate <-.874,.72,bd_wall_width*.25>
 }
 // 1st floor sep
 object{rbox2(.02,<bd_width,.15,bd_wall_width*.125>*.5)
  translate <0,2.45,-bd_wall_width*.075>
 }
 #if (use_decor=2)
 object{rbox2(.02,<bd_width,.05,bd_wall_width*.25>*.5)
  translate <0,2.50,-bd_wall_width*.125>
 }
 #end
 // 2nd floor windows
 object{rbox2(.01,<.97,.04,bd_wall_width>*.5)
  translate <.89,2.5+.72,bd_wall_width*.25>
 }
 object{rbox2(.01,<.97,.04,bd_wall_width>*.5)
  translate <-.87,2.5+.72,bd_wall_width*.25>
 }
 // 2nd floor sep
 object{rbox2(.02,<bd_width,.15,bd_wall_width*.125>*.5)
  translate <0,4.95,-bd_wall_width*.075>
 }
 object{rbox2(.02,<bd_width,.15,bd_wall_width*.5>*.5)
  translate <0,4.95+.15,-bd_wall_width*.25>
 }
 texture{t_ornament}
}

union{
 // facade hf
 object{hf_facade}
 // facade ornaments
 object{ornaments}
 // other decoration
 // doors and windows
 #if (use_door=1)
 object{door(t_wood,1000*rand(r_bd)) 
 #end
 #if (use_door=2)
 object{door2(t_wood,1000*rand(r_bd)) 
 #end
  rotate 180*y
  scale <.475,.495,.5>
  translate <.885,1.9*.5+.005,0>
  translate bd_wall_width*.4*z
 }
 object{window(t_wood,t_glass,t_metal,1000*rand(r_bd))
  scale <.47,.47,.5>
  translate <-.874,1.3,0>
  translate bd_wall_width*.6*z
 }
 #if (use_grill)
 object{window_grill
  texture{t_metal}
  translate <-.874,1.3+.04,0>
  translate bd_wall_width*.4*z
 }
 #end
 object{window(t_wood,t_glass,t_metal,1000*rand(r_bd))
  scale <.45,.47,.5>
  translate <.89,1.3+2.5+.01,0>
  translate bd_wall_width*.6*z
 }
 #if (use_grill)
 object{window_grill
  texture{t_metal}
  translate <.89,1.3+2.5+.05,0>
  translate bd_wall_width*.4*z
 }
 #end
 object{window(t_wood,t_glass,t_metal,1000*rand(r_bd))
  scale <.47,.47,.5>
  translate <-.870,1.3+2.5+.01,0>
  translate bd_wall_width*.6*z
 }
 #if (use_grill)
 object{window_grill
  texture{t_metal}
  translate <-.870,1.3+2.5+.05,0>
  translate bd_wall_width*.4*z
 }
 #end
 // tiled roof
}

#end // macro pov_building-1()


