// stone noise function for isosurfaces
#declare f_piedra=
function{
 pigment{
//  granite
//  wrinkles
//  crackle turbulence .5 scale .25
  marble turbulence 1 lambda 3
  color_map{
   [0.00 White*.2]
   [0.4 White*.5]
   [0.515 White]
   [0.520 White]
   [0.70 White*.5]
   [1.00 White*.2]
  }
  scale 2
 }
}

// rounded box isosurface macro : stone
#declare r_box=seed(637);
#macro rbox(R,S)
    #local Min=<-S.x,-S.y,-S.z>;
    #local Max=<S.x,S.y,S.z>;
    #local Sx=S.x;
    #local Sy=S.y;
    #local Sz=S.z;
    #local rk=rand(r_box);
    #if (use_rad=2)   
    box{-1,1 scale S}
    #else
    isosurface{
     function{f_rounded_box(x,y,z,R,Sx,Sy,Sz)
              //+f_granite(x*.25+rk,y*.25+rk,z*.25+rk)*.1
              +f_piedra(x*.05+rk,y*.05+rk,z*.05+rk).gray*.01
              }
        max_gradient 3
        contained_by{box{-S,S}}
        translate Min+S
    }
    #end
#end
// 2nd version
#macro rbox2(R,S)
    #local Min=<-S.x,-S.y,-S.z>;
    #local Max=<S.x,S.y,S.z>;
    #local Sx=S.x;
    #local Sy=S.y;
    #local Sz=S.z;
    #local rk=rand(r_box);
    #if (use_rad=2)   
    box{-1,1 scale S}
    #else
    isosurface{
     function{f_rounded_box(x,y,z,R,Sx,Sy,Sz)+
              f_granite(x+rk,y+rk,z+rk)*.01
              }
        max_gradient 3
        contained_by{box{-S,S}}
        translate Min+S
    }
    #end
#end

// rounded box isosurface macro: wood
#macro isowood(R,S)
    #local Min=<-S.x,-S.y,-S.z>;
    #local Max=<S.x,S.y,S.z>;
    #local Sx=S.x;
    #local Sy=S.y;
    #local Sz=S.z;
    #local rk=rand(r_box);
    #if (use_rad=2)   
    box{-1,1 scale S}
    #else
    isosurface{
     function{f_rounded_box(x,y,z,R,Sx,Sy,Sz)+f_wood(x*.25+rk,y*.25+rk,z*.25+rk)*.1}
        max_gradient 2
        contained_by{box{-S,S}}
        translate Min+S
    }
    #end
#end

// floor tiles crackle function
#declare f_roturas=
function{
 pigment{
  crackle turbulence .2
  color_map{
   [0.00 White]
   [0.05 Black]
   [1.0 Gray10]
  }
  scale 2
 }
}

